
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Track_contributorsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const track_contributors = await db.track_contributors.create(
            {
                id: data.id || undefined,
        
        name: data.name
        ||
        null
            ,
            
        role: data.role
        ||
        null
            ,
            
        spotify_artist_url: data.spotify_artist_url
        ||
        null
            ,
            
        apple_artist_url: data.apple_artist_url
        ||
        null
            ,
            
        society_identifier: data.society_identifier
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await track_contributors.setTrack( data.track || null, {
            transaction,
        });
        
        await track_contributors.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return track_contributors;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const track_contributorsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name: item.name
            ||
            null
            ,
            
                role: item.role
            ||
            null
            ,
            
                spotify_artist_url: item.spotify_artist_url
            ||
            null
            ,
            
                apple_artist_url: item.apple_artist_url
            ||
            null
            ,
            
                society_identifier: item.society_identifier
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const track_contributors = await db.track_contributors.bulkCreate(track_contributorsData, { transaction });

        // For each item created, replace relation files
        

        return track_contributors;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const track_contributors = await db.track_contributors.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.role !== undefined) updatePayload.role = data.role;
        
        
        if (data.spotify_artist_url !== undefined) updatePayload.spotify_artist_url = data.spotify_artist_url;
        
        
        if (data.apple_artist_url !== undefined) updatePayload.apple_artist_url = data.apple_artist_url;
        
        
        if (data.society_identifier !== undefined) updatePayload.society_identifier = data.society_identifier;
        
        
        updatePayload.updatedById = currentUser.id;

        await track_contributors.update(updatePayload, {transaction});

        
        
        if (data.track !== undefined) {
            await track_contributors.setTrack(
              
              data.track,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await track_contributors.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return track_contributors;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const track_contributors = await db.track_contributors.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of track_contributors) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of track_contributors) {
                await record.destroy({transaction});
            }
        });


        return track_contributors;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const track_contributors = await db.track_contributors.findByPk(id, options);

        await track_contributors.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await track_contributors.destroy({
            transaction
        });

        return track_contributors;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const track_contributors = await db.track_contributors.findOne(
            { where },
            { transaction },
        );

        if (!track_contributors) {
            return track_contributors;
        }

        const output = track_contributors.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.track = await track_contributors.getTrack({
            transaction
        });
        
        
        output.organizations = await track_contributors.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.tracks,
        as: 'track',
        
        where: filter.track ? {
          [Op.or]: [
            { id: { [Op.in]: filter.track.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.track.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'track_contributors',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.spotify_artist_url) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'track_contributors',
                        'spotify_artist_url',
                        filter.spotify_artist_url,
                    ),
                };
            }
            
            if (filter.apple_artist_url) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'track_contributors',
                        'apple_artist_url',
                        filter.apple_artist_url,
                    ),
                };
            }
            
            if (filter.society_identifier) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'track_contributors',
                        'society_identifier',
                        filter.society_identifier,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.role) {
                where = {
                    ...where,
                role: filter.role,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.track_contributors.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'track_contributors',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.track_contributors.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

